




<!DOCTYPE html>
<html>
<head>
<title>Django 用Session和Cookie分别实现记住用户登录状态 -  码上快乐</title>
<meta name="keywords" content="django,cookie,Django,session" />
<meta name="description" content="简介 由于http协议的请求是无状态的。故为了让用户在浏览器中再次访问该服务端时，他的登录状态能够保留 也可翻译为该用户访问这个服务端其他网页时不需再重复进行用户认证 。我们可以采用Cookie或Session这两种方式来让浏览器记住用户。 Cookie与Session说明与实现 Cookie 说明" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<meta http-equiv="X-UA-Compatible" content="ie=edge">
<meta http-equiv="Cache-Control" content="no-transform" />
<meta http-equiv="Cache-Control" content="no-siteapp" />
<meta name="applicable-device" content="pc,mobile">
<link href="/css/all.css?version=" rel="stylesheet">
<link href="/css/prettify.css?version=" rel="stylesheet">
</head>
<body onload="prettyPrint()">
    
<style>
.div2{top:45px;z-index:999;position:fixed;_position:absolute}
</style>
<div class="navbar navbar-inverse navbar-fixed-top">
	<div class="navbar-inner">
		<div class="container">
			<button data-target=".nav-collapse" data-toggle="collapse" class="btn btn-navbar" type="button">
				<span class="icon-bar"></span> 
				<span class="icon-bar"></span>
				<span class="icon-bar"></span>
			</button>
			<a class="brand" href="/index.html">码上快乐</a>
			<div class="nav-collapse collapse">
                <p class="navbar-text pull-right toplogin" style="margin-top:0px;">
	              <a href="javascript:void(0)" class="btn-show-login navbar-link">1秒登录</a>
	            </p>		
				<ul class="nav">
					<li class="navtop index"><a href="/index.html"><i class="icon-home icon-white"></i><strong>首页</strong></a></li>
					<li class="navtop recent"><a href="/rank.html"><i class="icon-fire icon-white"></i><strong>榜单</strong></a></li>
					<li class="navtop tags"><a href="/tags.html"><i class="icon-tag icon-white"></i><strong>标签</strong></a></li>
					<li class="navtop hot"><a href="/about.html"><i class="icon-heart icon-white"></i><strong>关于</strong></a></li>
					<li class="navtop hot"><a href="javascript:void(0);" rel="nofollow"><i class="icon-fire icon-white"></i><strong style="color:red" class="gptclass"></strong></a></li>
				</ul>
			</div>
		</div>
	</div>
</div>
<script src="/js/all.js?version="></script>

<!-- Global site tag (gtag.js) - Google Analytics -->

    <input name="ua" value="" type="hidden"/>
    <input name="title" value="Django 用Session和Cookie分别实现记住用户登录状态" type="hidden"/>
	<div class="container" style="padding-top:20px;">
		<div class="row-fluid m_b_20">
		    
			<div class="span2 visible-desktop" id="logo">
				<center>
					<a href="/index.html"><img src="/img/logo.png?version=" class="h_30"/></a>
				</center>
			</div>
			<div class="span6">
				<form class="form-search" action="/so" name="search-form">
					<div class="input-append span10">
						<center>
							<input type="text" class="span12 search-query" name="q" placeholder=" 请输入关键词搜索..." baiduSug="1">
							<button type="submit" class="btn btn-warning">搜索</button>
						</center>
					</div>
				</form>
			</div>
			<div class="span4 visible-desktop">
			    <a class="btn" href="/recommend/ae615d1/Django-用Session和Cookie分别实现记住用户登录状态"><i class="icon-random"></i>相关内容</a>
			    &nbsp;&nbsp;<a class="btn" href="https://www.codeprj.com/blog/ae615d1.html"><i class="icon-refresh"></i>简体</a>
			    &nbsp;&nbsp;<a class="btn" href="https://www.codeprj.com/zh/blog/ae615d1.html"><i class="icon-refresh"></i>繁体</a>
				
			</div>
		</div>
		<div class="row-fluid">
		    
			<div class="span8">
			    <div class="content_div">
			      <center>
			      <h3><a href="/blog/ae615d1.html" style="color:black">Django 用Session和Cookie分别实现记住用户登录状态</a></h3>
			      </center>
			      <div class="postinfo">
			              本文转载自
			      
			      <i class="icon-globe"></i>&nbsp;<a href="/go/aHR0cHM6Ly93d3cuY25ibG9ncy5jb20vamFjay0yMzMvcC8xMTQyODE4OS5odG1s" target="_blank">查看原文</a>
			      <i class="icon-time"></i>&nbsp;<span>2019-08-29 10:28</span>
			      <i class="icon-eye-open"></i>&nbsp;<span>394&nbsp;</span>
                  
                     <i class="icon-tag"></i>&nbsp;
                     
                     
                     
                     <span><a href='/tag/django' target="_blank">django</a>/</span>
                                          
                     
                     <span><a href='/tag/cookie' target="_blank">cookie</a>/</span>
                                          
                     
                     <span><a href='/tag/Django' target="_blank">Django</a>/</span>
                                          
                     
                     
                     <span><a href='/tag/session' target="_blank">session</a></span>                     
                     
                  
                  <i class="icon-star" title="1.1462"></i>
                  
                  
                  
                                    
			      </div>
			      <hr/>
                 <div class="media-body" id="content_div">
                    <div class="title_down_ad ad">
					</div>
					<div class="post_content" id="postContent">
					  <h2 id="简介">简介</h2> 
<blockquote> 
 <p>由于http协议的请求是无状态的。故为了让用户在浏览器中再次访问该服务端时，他的登录状态能够保留（也可翻译为该用户访问这个服务端其他网页时不需再重复进行用户认证）。我们可以采用Cookie或Session这两种方式来让浏览器记住用户。</p> 
</blockquote> 
<h2 id="cookie与session说明与实现">Cookie与Session说明与实现</h2> 
<h3 id="cookie">Cookie</h3> 
<h4 id="说明">说明</h4> 
<p>Cookie是一段小信息(数据格式一般是类似key-value的键值对)，由服务器生成，并发送给浏览器让浏览器保存(保存时间由服务端定夺)。当浏览器下次访问该服务端时，会将它保存的Cookie再发给服务器，从而让服务器根据Cookie知道是哪个浏览器或用户在访问它。（由于浏览器遵从的协议，它不会把该服务器的Cookie发送给另一个不同host的服务器）。</p>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<h4 id="django中实现cookie">Django中实现Cookie</h4> 
<pre><code class="language-python">from django.shortcuts import render, redirect

# 设置cookie
"""
key: cookie的名字
value: cookie对应的值
max_age: cookie过期的时间
"""
response.set_cookie(key, value, max_age)
# 为了安全，有时候我们会调用下面的函数来给cookie加盐
response.set_signed_cookie(key,value,salt='加密盐',...)

# 获取cookie 
request.COOKIES.get(key)
request.get_signed_cookie(key, salt="加密盐", default=None)

# 删除cookie
reponse.delete_cookie(key)
</code></pre> 
<p>下面就是具体的代码实现了<br> views.py</p> 
<pre><code class="language-python"># 编写装饰器检查用户是否登录
def check_login(func):
    def inner(request, *args, **kwargs):
        next_url = request.get_full_path()
        # 假设设置的cookie的key为login，value为yes
        if request.get_signed_cookie("login", salt="SSS", default=None) == 'yes':
            # 已经登录的用户，则放行
            return func(request, *args, **kwargs)
        else:
            # 没有登录的用户，跳转到登录页面
            return redirect(f"/login?next={next_url}")

    return inner


# 编写用户登录页面的控制函数
@csrf_exempt
def login(request):
    if request.method == "POST":
        username = request.POST.get("username")
        passwd = request.POST.get("password")
        next_url = request.POST.get("next_url")

        # 对用户进行验证，假设用户名为：aaa, 密码为123
        if username === 'aaa' and passwd == '123':
            # 执行其他逻辑操作，例如保存用户信息到数据库等
            # print(f'next_url={next_url}')
            # 登录成功后跳转,否则直接回到主页面
            if next_url and next_url != "/logout/":
                response = redirect(next_url)
            else:
                response = redirect("/index/")
            # 若登录成功，则设置cookie，加盐值可自己定义取，这里定义12小时后cookie过期
            response.set_signed_cookie("login", 'yes', salt="SSS", max_age=60*60*12)
            return response
        else:
            # 登录失败，则返回失败提示到登录页面
            error_msg = '登录验证失败，请重新尝试'
            return render(request, "app/login.html", {
                'login_error_msg': error_msg,
                'next_url': next_url,
            })
    # 用户刚进入登录页面时，获取到跳转链接，并保存
    next_url = request.GET.get("next", '')
    return render(request, "app/login.html", {
        'next_url': next_url
    })


# 登出页面
def logout(request):
    rep = redirect("/login/")
    # 删除用户浏览器上之前设置的cookie
    rep.delete_cookie('login')
    return rep


# 给主页添加登录权限认证
@check_login
def index(request):
    return render(request, "app/index.html")
</code></pre>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<p>由上面看出，其实就是在第一次用户登录成功时，设置cookie，用户访问其他页面时进行cookie验证，用户登出时删除cookie。另外附上前端的login.html部分代码</p> 
<pre><code class="language-html">            &lt;form action="{% url 'login' %}" method="post"&gt;
              &lt;h1&gt;请使xx账户登录&lt;/h1&gt;
              &lt;div&gt;
                &lt;input id="user" type="text" class="form-control" name="username" placeholder="账户" required="" /&gt;
              &lt;/div&gt;
              &lt;div&gt;
                &lt;input id="pwd" type="password" class="form-control" name="password" placeholder="密码" required="" /&gt;
              &lt;/div&gt;
                &lt;div style="display: none;"&gt;
                    &lt;input id="next" type="text" name="next_url" value="{{ next_url }}" /&gt;
                &lt;/div&gt;
                {% if login_error_msg %}
                    &lt;div id="error-msg"&gt;
                        &lt;span style="color: rgba(255,53,49,0.8); font-family: cursive;"&gt;{{ login_error_msg }}&lt;/span&gt;
                    &lt;/div&gt;
                {% endif %}
              &lt;div&gt;
                  &lt;button type="submit" class="btn btn-default" style="float: initial; margin-left: 0px"&gt;登录&lt;/button&gt;
              &lt;/div&gt;
            &lt;/form&gt;
</code></pre> 
<h3 id="session">Session</h3> 
<h4 id="session说明">Session说明</h4>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<p>Session则是为了保证用户信息的安全，将这些信息保存到服务端进行验证的一种方式。但它却依赖于cookie。具体的过程是：服务端给每个客户端(即浏览器)设置一个cookie（从上面的cookie我们知道，cookie是一种”key, value“形式的数据，这个cookie的value是服务端随机生成的一段但唯一的值）。<br> 当客户端下次访问该服务端时，它将cookie传递给服务端，服务端得到cookie，根据该cookie的value去服务端的Session数据库中找到该value对应的用户信息。（Django中在应用的setting.py中配置Session数据库）。<br> 根据以上描述，我们知道Session把用户的敏感信息都保存到了服务端数据库中，这样具有较高的安全性。</p> 
<h4 id="django中session的实现">Django中Session的实现</h4> 
<pre><code class="language-python"># 设置session数据, key是字符串，value可以是任何值
request.session[key] = value
# 获取 session
request.session.get[key]
# 删除 session中的某个数据
del request.session[key]
# 清空session中的所有数据
request.session.delete()
</code></pre> 
<p>下面就是具体的代码实现了：<br> 首先就是设置保存session的数据库了。这个在setting.py中配置：(注意我这里数据库用的mongodb，并使用了django_mongoengine库；关于这个配置请根据自己使用的数据库进行选择，具体配置可参考<a href="/link/aHR0cHM6Ly9kb2NzLmRqYW5nb3Byb2plY3QuY29tL3poLWhhbnMvMi4yL3JlZi9zZXR0aW5ncy8jc3RkOnNldHRpbmctU0VTU0lPTl9FTkdJTkU=" rel="nofollow noopener" target="_blank">官方教程</a>)</p>
<ins class="adsbygoogle" style="display:block; text-align:center;" data-ad-layout="in-article" data-ad-format="fluid" data-ad-client="ca-pub-4353345653789615" data-ad-slot="4890554435"></ins>
<script>     (adsbygoogle = window.adsbygoogle || []).push({});</script> 
<pre><code class="language-python">SESSION_ENGINE = 'django_mongoengine.sessions'
SESSION_SERIALIZER = 'django_mongoengine.sessions.BSONSerializer'
</code></pre> 
<p>views.py</p> 
<pre><code class="language-python"># 编写装饰器检查用户是否登录
def check_login(func):
    def inner(request, *args, **kwargs):
        next_url = request.get_full_path()
        # 获取session判断用户是否已登录
        if request.session.get('is_login'):
            # 已经登录的用户...
            return func(request, *args, **kwargs)
        else:
            # 没有登录的用户，跳转刚到登录页面
            return redirect(f"/login?next={next_url}")

    return inner


@csrf_exempt
def login(request):
    if request.method == "POST":
        username = request.POST.get("username")
        passwd = request.POST.get("password")
        next_url = request.POST.get("next_url")
        # 若是有记住密码功能
        # remember_sign = request.POST.get("check_remember")
        # print(remember_sign)

        # 对用户进行验证
        if username == 'aaa' and passwd == '123':
            # 进行逻辑处理，比如保存用户与密码到数据库

            # 若要使用记住密码功能，可保存用户名、密码到session
            # request.session['user_info'] = {
                # 'username': username,
                # 'password': passwd
            # }
            request.session['is_login'] = True
            # 判断是否勾选了记住密码的复选框
            # if remember_sign == 'on':
            #   request.session['is_remember'] = True
            # else:
                # request.session['is_remember'] = False

            # print(f'next_url={next_url}')
            if next_url and next_url != "/logout/":
                response = redirect(next_url)
            else:
                response = redirect("/index/")
            return response
        else:
            error_msg = '登录验证失败，请重新尝试'
            return render(request, "app/login.html", {
                'login_error_msg': error_msg,
                'next_url': next_url,
            })
    next_url = request.GET.get("next", '')
    # 检查是否勾选了记住密码功能
    # password, check_value = '', ''
    # user_session = request.session.get('user_info', {})
    # username = user_session.get('username', '')
    # print(user_session)
    #if request.session.get('is_remember'):
    #    password = user_session.get('password', '')
    #    check_value = 'checked'
    # print(username, password)
    return render(request, "app/login.html", {
        'next_url': next_url,
        # 'user': username,
        # 'password': password,
        # 'check_value': check_value
    })


def logout(request):
    rep = redirect("/login/")
    # request.session.delete()
    # 登出，则删除掉session中的某条数据
    if 'is_login' in request.session:
        del request.session['is_login']
    return rep


@check_login
def index(request):
    return render(request, "autotest/index.html")
</code></pre> 
<p>另附login.html部分代码：</p> 
<pre><code class="language-html">            &lt;form action="{% url 'login' %}" method="post"&gt;
              &lt;h1&gt;请使xxx账户登录&lt;/h1&gt;
              &lt;div&gt;
                &lt;input id="user" type="text" class="form-control" name="username" placeholder="用户" required="" value="{{ user }}" /&gt;
              &lt;/div&gt;
              &lt;div&gt;
                &lt;input id="pwd" type="password" class="form-control" name="password" placeholder="密码" required="" value="{{ password }}" /&gt;
              &lt;/div&gt;
                &lt;div style="display: none;"&gt;
                    &lt;input id="next" type="text" name="next_url" value="{{ next_url }}" /&gt;
                &lt;/div&gt;
                {% if login_error_msg %}
                    &lt;div id="error-msg"&gt;
                        &lt;span style="color: rgba(255,53,49,0.8); font-family: cursive;"&gt;{{ login_error_msg }}&lt;/span&gt;
                    &lt;/div&gt;
                {% endif %}
                // 若设置了记住密码功能
               // &lt;div style="float: left"&gt;
               //     &lt;input id="rmb-me" type="checkbox" name="check_remember" {{ check_value }}/&gt;记住密码
               // &lt;/div&gt;
              &lt;div&gt;
                  &lt;button type="submit" class="btn btn-default" style="float: initial; margin-right: 60px"&gt;登录&lt;/button&gt;
              &lt;/div&gt;
            &lt;/form&gt;
</code></pre> 
<p>总的来看，session也是利用了cookie，通过cookie生成的value的唯一性，从而在后端数据库session表中找到这value对应的数据。session的用法可以保存更多的用户信息，并使这些信息不易被暴露。</p> 
<h2 id="总结">总结</h2> 
<p>session和cookie都能实现记住用户登录状态的功能，如果为了安全起见，还是使用session更合适</p> 
<p>参考文章：<a href="/link/aHR0cHM6Ly9ibG9nLmNzZG4ubmV0L3FxXzM0NzU1MDgxL2FydGljbGUvZGV0YWlscy84MjgwODUzNw==" rel="nofollow noopener" target="_blank">https://blog.csdn.net/qq_34755081/article/details/82808537</a></p>
					</div>      
                    <div class="read-more" id="read-more" style="display:none"></div>        
                    <div class="alert alert-info" style="margin-top:20px;">
				      <p id="tips_top1">
				      </p>
			        </div>
			        <script type="text/javascript">
			         $("#tips_top1").append("<strong><i class=\"icon-fire\"></i>温馨提示：</strong>如果本文未解决您的问题，可以免费向大模型提问：<strong><a href='javascript:void(0)' class='gptbtn'>向AI大模型提问</a></strong>。");
			        </script>				        
					<div class="iframe-container">
					</div>
                 </div>
                 
			      
			      <div class="ad_content_down ad">
			      </div>                 
			    </div>
			     
			     <div class="disclaimer visible-desktop">
			         <br/>
		             <div class="alert alert-block">
		              <button type="button" class="close" data-dismiss="alert">×</button>
		              <h4>免责声明！</h4>
		                 <p>本站转载的文章为个人学习借鉴使用，本站对版权不负任何法律责任。如果侵犯了您的隐私权益，请联系本站邮箱yoyou2525@163.com删除。</p>
		            </div>	
		            <br/><br/>
                 </div>
			</div>
			
			<!-- 右边相关博客和资料 -->
			<div class="span4 left_content">
			  <div id="left_list_div" class="left_content">
			   <span class="list-group-item" href="javascript:void(0)"><i class="icon-filter"></i><strong>猜您在找</strong></span>
			   
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/d2a97a1.html" title="Flask网页session记住用户登录状态">
			           
			           <i class="icon-file"></i>
			           Flask网页session记住用户登录状态
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/727f3d1.html" title="session、cookie 记住登录状态的实现">
			           
			           <i class="icon-file"></i>
			           session、cookie 记住登录状态的实现
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/29a6891.html" title="session、cookie与“记住我的登录状态”的功能的实现">
			           <i class="icon-fire"></i>
			           
			           session、cookie与“记住我的登录状态”的功能的实现
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/9565191.html" title="Cookie、Session实现“记住登录状态”的原理">
			           <i class="icon-fire"></i>
			           
			           Cookie、Session实现“记住登录状态”的原理
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/7bc25d1.html" title="session、cookie与“记住我的登录状态”的功能的实现">
			           <i class="icon-fire"></i>
			           
			           session、cookie与“记住我的登录状态”的功能的实现
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/b9cd3c1.html" title="Django（十三）状态保持 —— cookie与session+ajax异步请求+session记住登录状态+cookie记住登录名密码">
			           
			           <i class="icon-file"></i>
			           Django（十三）状态保持 —— cookie与session+ajax异步请求+session记住登录状态+cookie记住登录名密码
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/8c5f9c1.html" title="通过jquery.cookie.js实现记住用户名、密码登录功能">
			           
			           <i class="icon-file"></i>
			           通过jquery.cookie.js实现记住用户名、密码登录功能
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/9140281.html" title="通过jquery.cookie.js实现记住用户名、密码登录功能">
			           
			           <i class="icon-file"></i>
			           通过jquery.cookie.js实现记住用户名、密码登录功能
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/b1595a1.html" title="Java 之 cookie 记住用户登录时间案例">
			           
			           <i class="icon-file"></i>
			           Java 之 cookie 记住用户登录时间案例
			           </a>
			       			       
			   
			       
			       
			           
			           <a class='list-group-item' href="/blog/7841af1.html" title="完成登录功能，用session记住用户名">
			           
			           <i class="icon-file"></i>
			           完成登录功能，用session记住用户名
			           </a>
			       			       
			   
			   
			   <div id="right_float_ad" class="ad">
				</div>
			</div>
			</div>
		</div>
	</div>
    <div class="clear">&nbsp;</div>
    



<div class="fbar" style="z-index:100">
	<div class="span7" style="color:grey;font-size:12px;">
	</div>
	<div class="pull-right">
		<span><a href="http://beian.miit.gov.cn" rel="nofollow" target="_blank">粤ICP备18138465号</a>&nbsp;&nbsp;</span><span>&copy; 2018-2024 CODEPRJ.COM </span> 
	</div>
</div>
<script src="/js/code.js?version=20240329"></script>
<script>
   function buffer(a, b, c) {
	    var d;
	    return function() {
	        if (d) return;
	        d = setTimeout(function() {
	            a.call(this),
	            d = undefined
	        },
	        b)
	    }
	} 

	(function() {
	    function e() {
	        var d = document.body.scrollTop || document.documentElement.scrollTop;
	        d > b ? (a.className = "div1 div2", c && (a.style.top = d - b + "px")) : a.className = "div1"
	    }
	    var a = document.getElementById("float");
	    if (a == undefined) return ! 1;
	    var b = 0,
	    c, d = a;
	    while (d) b += d.offsetTop,
	    d = d.offsetParent;
	    c = window.ActiveXObject && !window.XMLHttpRequest;
	    if (!c || !0) window.onscroll = buffer(e, 50, this)
	})(); 

</script>

<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?85c5e8e7b6167edfc87cb0607142e870";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

    
    
</body>
</html>